"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSimpleViewSlider = createSimpleViewSlider;
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var React = _interopRequireWildcard(require("react"));
var _inlineStylePrefixer = _interopRequireDefault(require("inline-style-prefixer"));
var _index = _interopRequireDefault(require("./index.js"));
var _excluded = ["children", "spacing", "rtl", "keepViewsMounted", "keepPrecedingViewsMounted"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _callSuper(t, o, e) { return o = (0, _getPrototypeOf2["default"])(o), (0, _possibleConstructorReturn2["default"])(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2["default"])(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); } /* eslint-env browser */
function defaultRenderView(_ref) {
  var index = _ref.index;
  return this.state.views[index];
}
function createSimpleViewSlider(ViewSlider) {
  var renderView = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultRenderView;
  return /*#__PURE__*/function (_React$Component) {
    function SimpleViewSlider(props) {
      var _this;
      (0, _classCallCheck2["default"])(this, SimpleViewSlider);
      _this = _callSuper(this, SimpleViewSlider, [props]);
      (0, _defineProperty2["default"])(_this, "renderView", renderView.bind(_this));
      (0, _defineProperty2["default"])(_this, "handleSlideTransitionEnd", function () {
        if (!_this.props.keepViewsMounted) {
          var _this$state = _this.state,
            views = _this$state.views,
            activeView = _this$state.activeView;
          if (activeView < views.length - 1) {
            _this.setState({
              views: views.slice(0, activeView + 1)
            }, function () {
              var onSlideTransitionEnd = _this.props.onSlideTransitionEnd;
              if (onSlideTransitionEnd) onSlideTransitionEnd();
            });
          }
        }
      });
      var child = React.Children.only(props.children);
      var _activeView = parseInt(child.key);
      var _views = [];
      _views[_activeView] = child;
      _this.state = {
        views: _views,
        activeView: _activeView
      };
      return _this;
    }
    (0, _inherits2["default"])(SimpleViewSlider, _React$Component);
    return (0, _createClass2["default"])(SimpleViewSlider, [{
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        if (prevProps.children !== this.props.children) {
          var child = React.Children.only(this.props.children);
          var activeView = parseInt(child.key);
          var views = (0, _toConsumableArray2["default"])(this.state.views);
          views[activeView] = child;
          this.setState({
            views: views,
            activeView: activeView
          });
        }
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
          children = _this$props.children,
          spacing = _this$props.spacing,
          rtl = _this$props.rtl,
          keepViewsMounted = _this$props.keepViewsMounted,
          keepPrecedingViewsMounted = _this$props.keepPrecedingViewsMounted,
          props = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
        var _this$state2 = this.state,
          activeView = _this$state2.activeView,
          views = _this$state2.views;
        return /*#__PURE__*/React.createElement(ViewSlider, (0, _extends2["default"])({}, props, {
          keepViewsMounted: keepViewsMounted || keepPrecedingViewsMounted,
          spacing: spacing,
          rtl: rtl,
          renderView: this.renderView,
          numViews: views.length,
          activeView: activeView,
          onSlideTransitionEnd: this.handleSlideTransitionEnd
        }));
      }
    }]);
  }(React.Component);
}
var _default = exports["default"] = createSimpleViewSlider(_index["default"]);